/*\
|*| --------------------------------------------------------------------------
|*|	SC 15025 / SC 15026 ramdac register definitions
|*| --------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1996, Steffen Seeger, [seeger@physik.tu-chemnitz.de]
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
\*/

/* MAINTAINER	Steffen Seeger,	[seeger@physik.tu-chemnitz.de]	*/

#ifndef _SC_1502x_H
#define	_SC_1502x_H

#include "IBM/vga_dac.h"	/* standard registers		*/

/*\
|*|	these registers are accessed when the EPRF flag is 0
\*/

#define	DAC_OL_INDEX	0x4	/* overlay RAM write index	*/

#define	DAC_OL_DATA	0x5	/* overlay data (r/w) register	*/

#define	DAC_COMMAND	0x6	/* command register		*/
	#define	DAC_CMD_EXTPAL0	0x02	/* ext palette bits	*/
	#define	DAC_CMD_EXTPAL1	0x04	/* ext palette bits	*/
	#define	DAC_CMD_USECLUT	0x08	/* only modes 1,2,3,4,5 */
	#define	DAC_CMD_ERPF	0x10	/* ext. reg. prog. flag	*/
	#define	DAC_CMD_DBL_CLK	0x00	/* fetch at both edges	*/
	#define	DAC_CMD_NRM_CLK	0x20	/* fetch at rising edge	*/
	#define	DAC_CMD_MODEMASK	0xC1
	#define	DAC_CMD_MODE0	0x00	/* 8bpp pseudo color	*/
	#define	DAC_CMD_MODE1	0x80	/* 15bpp		*/
	#define	DAC_CMD_MODE2	0x81	/* extended 15bpp	*/
	#define	DAC_CMD_MODE3	0xC0	/* 16bpp		*/
	#define	DAC_CMD_MODE4	0x40	/* 24bpp RGB		*/
	#define	DAC_CMD_MODE5	0x41	/* 24bpp BGR		*/

#define	DAC_OL_READ	0x7	/* overlay RAM read index	*/

/*\
|*|	these registers are accessed when the EPRF flag is 1
\*/

#define	DAC_E_DATA	0x0	/* extended data register	*/

#define	DAC_E_INDEX_R	0x3	/* extended index (read only)	*/

#define	DAC_E_COMMAND	0x2	/* command register 		*/
	/* same as DAC_COMMAND	*/

#define	DAC_E_INDEX_W	0x3	/* extended index (write only)	*/

/*\
|*|	extended registers
\*/

#define	DAC_EXT_AUXCTRL	0x08	/* auxiliary control register	*/
	#define	DAC_AUX_8BIT	0x01	/* 8bit color precision	*/
#define	DAC_EXT_ID0	0x09	/* should be 0x53		*/
#define	DAC_EXT_ID1	0x0A	/* should be 0x3A		*/
#define	DAC_EXT_ID2	0x0B	/* should be 0xB1		*/
#define	DAC_EXT_ID3	0x0C	/* version number		*/
#define	DAC_EXT_PIX_MASK0	0x0D	/* low byte			*/
#define	DAC_EXT_PIX_MASK1	0x0E	/* middle byte			*/
#define	DAC_EXT_PIX_MASK2	0x0F	/* high byte			*/
#define	DAC_EXT_REPACK	0x10	/* pixel value repack control	*/
	#define	DAC_REP_MODE0	0x00
	#define	DAC_REP_MODE1	0x01

#endif	/* _SC_1502x_H */
