/* --------------------------------------------------------------------------
**	graphic devices definitions
** --------------------------------------------------------------------------
**
**	Copyright (C) 1996, The GGI project.
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2, or (at your option)
**	any later version.
**
**	You should have received a copy of the GNU General Public License
**	along with this program; see the file COPYING.  If not, write to
**	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
** ---------------------------------------------------------------------------
*/

#ifndef	_GGI_GRAPHIC_H
#define	_GGI_GRAPHIC_H

#define	MAX_NR_MMIO_REGIONS	16	/* max. mmio regions per card	*/
#define	MAX_NR_ACCEL_REGIONS	8	/* max. accelerators per card	*/

struct kgi_graphic {

	struct kgi_device	dev;	/* normal device state	*/

	ggi_uint	io_cnt;
	void	*io_buf;
	void	*io_res;
	ggi_uint	io_lock;

	ggi_uint	can_set_mode;

	struct kgi_mmio_mapping *mmio_map[MAX_NR_MMIO_REGIONS];
	struct kgi_mmio_region	*mmio[MAX_NR_MMIO_REGIONS];

	struct kgi_accel_mapping *accel_map[MAX_NR_ACCEL_REGIONS];
	struct kgi_accel	*accel[MAX_NR_ACCEL_REGIONS];

	ggi_event_buffer *evbufs;
	struct wait_queue *waiting_for_event;

	ggi_gc	*gc;		/* gc as mapped into kernelspace */

	/* !!! add other state not already in dev!	*/
};

#ifdef NEED_GRAPHIC_DEFS

#define	DEV	(graph->dev)
#define	TTY	(graph->dev.tty)
#define	IO_BUF	(graph->io_buf)
#define	IO_RES	(graph->io_res)
#define	IO_CNT	(graph->io_cnt)
#define	IO_LOCK	(graph->io_lock)
#define	IO_BUF_SIZE	2*PAGE_SIZE
#define	MMIO_MAP	(graph->mmio_map)
#define	MMIO		(graph->mmio)
#define	ACCEL_MAP	(graph->accel_map)
#define	ACCEL		(graph->accel)
#define	EVBUFS		(graph->evbufs)
#define	GC		(graph->gc)

#endif /* #ifdef NEED_GRAPHIC_DEFS */

#ifdef __KERNEL__

extern int dev_graphic_init(void);

#endif	/* #ifdef __KERNEL__ */

#endif	/* _GGI_GRAPHIC_H */
