#ifndef _SERIALMOUSE_H_
#define _SERIALMOUSE_H_

enum mouse_id {
	MOUSE_TYPE_MICROSOFT=0,	/* Microsoft	2-button */
	MOUSE_TYPE_MOUSESYS,	/* MouseSystems	3-button */
	MOUSE_TYPE_LOGITECH,	/* Logitech	3-button */
	MOUSE_TYPE_LAST
};

#define MOUSE_TYPE_DEFAULT	MOUSE_TYPE_MICROSOFT
#define MOUSE_MAGIC		0xF00DBAD0
#define MOUSE_MAX_DEVS		16
#define MOUSE_MAX_PACKET_LEN 	8


struct serialmouse_attr {
	int  display;
	enum mouse_id type;
};

#define MOUSE_IOCTL_TYPE	'z'

#define MOUSE_IOCTL_GETATTR		0
#define MOUSE_IOCTL_SETATTR		1

#define MOUSEGATTR _IOR(MOUSE_IOCTL_TYPE,\
			MOUSE_IOCTL_GETATTR,struct serialmouse_attr)
#define MOUSESATTR _IOWR(MOUSE_IOCTL_TYPE,\
			 MOUSE_IOCTL_SETATTR,struct serialmouse_attr)

#endif /* _SERIALMOUSE_H_ */
