/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"

/****************************************/
/* draw a circle - highly optimized ;-) */
/****************************************/
int GGIdrawcircle(ggi_visual *vis,int xcenter,int ycenter,int radius)
{	
	int x,y,od,md,sd;

	CHECKXYWH(vis,xcenter,ycenter,radius,radius);

	x=radius;y=md=0;
	while(x>=y) {
	  ggiDrawPixel(vis,xcenter-y,ycenter-x);
	  ggiDrawPixel(vis,xcenter+y,ycenter-x);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}
	x=radius;y=md=0;
	while(x>=y) {
	  ggiDrawPixel(vis,xcenter+x,ycenter-y);
	  ggiDrawPixel(vis,xcenter-x,ycenter-y);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}
	x=radius;y=md=0;
	while(x>=y) {
	  ggiDrawPixel(vis,xcenter-x,ycenter+y);
          ggiDrawPixel(vis,xcenter+x,ycenter+y);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}
	x=radius;y=md=0;
	while(x>=y) {
          ggiDrawPixel(vis,xcenter+y,ycenter+x);
          ggiDrawPixel(vis,xcenter-y,ycenter+x);
	  od=md+y+y+1;sd=od-x-x-1;y++;md=od;
	  if (abs(sd)<abs(od)) {x--;md=sd;}
	}

	return(0);
}
