/*
    Copyright (C) 1997 Uwe Maurer - uwe_maurer@t-online.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <ggi/libggi.h>

int load1(ggi_visual_t vis,const char *driver,const char *args)
{
	printf("load extension 1 - vis: %i \"%s\",\"%s\"\n",
		(int)vis,driver,args);

	return GGI_DL_EXTENSION;
}

int release1(ggi_visual_t vis,const char *driver)
{
	printf("release extension 1 - vis: %i \"%s\"\n",(int)vis,driver);
	return 0;
}

int load2(ggi_visual_t vis,const char *driver,const char *args)
{
	printf("load extension 2 - vis: %i \"%s\",\"%s\"\n",
		(int)vis,driver,args);
	return GGI_DL_EXTENSION;
}

int release2(ggi_visual_t vis,const char *driver)
{
	printf("release extension 2 - vis: %i \"%s\"\n",(int)vis,driver);
	return 0;
}


void main()
{
	ggi_visual_t vis1,vis2;
	int off;
	ggiInit();

	off=ggiRegisterExtension(123,load1,release1);
	printf("off: %i\n",off);

	vis1=ggiOpen(NULL);
	ggiSetGraphMode(vis1,320,200,320,200,GT_8BIT);
	ggiSetGraphMode(vis1,320,400,320,400,GT_8BIT);

	off=ggiRegisterExtension(456,load2,release2);
	printf("off: %i\n",off);

	vis2=ggiOpen("display-memory",NULL);
	ggiSetGraphMode(vis2,320,200,320,200,GT_8BIT);


	ggiClose(vis1);
	ggiClose(vis2);

	ggiExit();
}
