/* 
   Mystique text16 library, derived from Graphics library for GGI Pixels.

   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu
   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Matthias Grimrath - m.grimrath@tu-bs.de

   Anyone is welcome to improve this lib and send diffs to us.
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"

#include <Matrox/mga_common_lib.h>
#include <Matrox/mga1064_main.h>

/*******************************/
/* draw/get/put a single pixel */
/*******************************/

int GGIdrawpixel(ggi_visual *vis,int x,int y)
{
	CHECKXY(vis,x,y);

	(((mgatext *)VIS_FB_LINEAR(vis))+y*VIS_FB_WIDTH(vis)+x)->ca = 
	  VIS_GC_FGCOLOR(vis);

	return EOK;
}

int GGIputpixel(ggi_visual *vis,int x,int y,ggi_uint col)
{ 
	CHECKXY(vis,x,y);

	(((mgatext *)VIS_FB_LINEAR(vis))+y*VIS_FB_WIDTH(vis)+x)->ca=col;

	return EOK;
}

int GGIgetpixel(ggi_visual *vis,int x,int y,ggi_uint *pixel)
{ 
	if (pixel==NULL)
		return -1;

	CHECKXY(vis,x,y);

	*pixel = (((mgatext *)VIS_FB_LINEAR(vis))+y*VIS_FB_WIDTH(vis)+x)->ca;

	return EOK;
	
}
